var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import { DEFAULT_SCOPE, DEFAULT_OAUTH_PREFIX, DEFAULT_AUTHORIZE_TIMEOUT_IN_SECONDS, DEFAULT_AUTO_REFRESH, } from '../constants';
import { AuthorizationRequest } from './AuthorizationRequest';
import { parseQueryResult } from '../utils/queryString';
import { Authorization } from './Authorization';
import { getJSON, cleanUrl } from '../utils/xhr';
import { JWT } from './JWT';
import { runIframe } from '../utils/iframe';
// const lock = new Lock();
var currentSignInRequest;
var LaravelPassportClient = /** @class */ (function () {
    /**
     * Build Laravel Passport Client based on given options.
     * @param options
     */
    function LaravelPassportClient(options) {
        // madatory
        this.domain = options.domain;
        this.client_id = options.client_id;
        this.redirect_uri = options.redirect_uri;
        // optional
        this._oauthPrefix = options.oauthPrefix;
        this._scope = options.scope;
        this._authorizeTimeoutInSeconds = options.authorizeTimeoutInSeconds;
        this._isAutoRefresh = options.isAutoRefresh;
        // internal
        this._token = undefined;
    }
    Object.defineProperty(LaravelPassportClient.prototype, "oauthPrefix", {
        get: function () {
            return this._oauthPrefix || DEFAULT_OAUTH_PREFIX;
        },
        set: function (value) {
            this._oauthPrefix = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(LaravelPassportClient.prototype, "scope", {
        get: function () {
            return this._scope || DEFAULT_SCOPE;
        },
        set: function (value) {
            this._scope = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(LaravelPassportClient.prototype, "authorizeTimeoutInSeconds", {
        get: function () {
            return this._authorizeTimeoutInSeconds || DEFAULT_AUTHORIZE_TIMEOUT_IN_SECONDS;
        },
        set: function (value) {
            this._authorizeTimeoutInSeconds = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(LaravelPassportClient.prototype, "isAutoRefresh", {
        get: function () {
            return this._isAutoRefresh !== undefined ? this._isAutoRefresh : DEFAULT_AUTO_REFRESH;
        },
        set: function (value) {
            this._isAutoRefresh = value;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * ```js
     * lpClient.getToken();
     * ```
     *
     * Get the token this client has in cache.
     */
    LaravelPassportClient.prototype.getToken = function () {
        return __awaiter(this, void 0, void 0, function () {
            var currentScope;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!(this.isAutoRefresh && !this.isTokenValid())) return [3 /*break*/, 2];
                        currentScope = this._token ? this._token.scopesAsString() : undefined;
                        return [4 /*yield*/, this.signIn(currentScope)];
                    case 1:
                        _a.sent();
                        _a.label = 2;
                    case 2: return [2 /*return*/, this._token ? this._token.raw : null];
                }
            });
        });
    };
    /**
     * ```js
     * lpClient.getTokenScopes();
     * ```
     *
     * Get this client token's scope(s).
     */
    LaravelPassportClient.prototype.getTokenScopes = function () {
        return this._token ? this._token.scopes : null;
    };
    /**
     * ```js
     * lpClient.getTokenExpiration();
     * ```
     *
     * Get this client token's expiration date.
     */
    LaravelPassportClient.prototype.getTokenExpiration = function () {
        return this._token ? this._token.expiration : null;
    };
    /**
     * ```js
     * lpClient.isTokenValid();
     * ```
     *
     * Returns `true` if the client has a token which is not expired, `false` otherwise.
     */
    LaravelPassportClient.prototype.isTokenValid = function () {
        return !!this._token && !this._token.isExpired();
    };
    /**
     * ```js
     * lpClient.getSignedInUserId();
     * ```
     *
     * Get this client token's user id.
     */
    LaravelPassportClient.prototype.getSignedInUserId = function () {
        return this.isTokenValid() ? this._token.user_id : null;
    };
    /**
     * ```js
     * await lpClient.signIn();
     * ```
     *
     * Sign the client in. Starts with the iframe flow and fallsback to redirect flow if needed.
     * Resolves on `true` if the sign in has been successful, `false` otherwise.
     * @param {?string} scope
     */
    LaravelPassportClient.prototype.signIn = function (scope) {
        return __awaiter(this, void 0, void 0, function () {
            var isSignedInSilently;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.executeSignIn('iframe', scope)];
                    case 1:
                        isSignedInSilently = _a.sent();
                        if (!!isSignedInSilently) return [3 /*break*/, 3];
                        return [4 /*yield*/, this.signInWithRedirect(scope)];
                    case 2:
                        _a.sent();
                        _a.label = 3;
                    case 3: return [2 /*return*/, isSignedInSilently];
                }
            });
        });
    };
    /**
     * ```js
     * await lpClient.signInWithRedirect(scope);
     * ```
     *
     * Redirect to the authorize URL (`'/oauth/authorize'` by default) with appropriate
     * AuthorizeParameters. If provided, the given scope value will override the client's
     * default scope.
     * @param {?string} scope
     */
    LaravelPassportClient.prototype.signInWithRedirect = function (scope) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.executeSignIn('redirect', scope)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * ```js
     * await lpClient.handleRedirectCallback();
     * ```
     *
     * Extract the authorization code returned in the query string, build the Authorization Signature and calls
     * `exchangeAuthorizationForToken` with it. Returns `true` if a token is obtained, `false`
     * otherwise.
     */
    LaravelPassportClient.prototype.handleRedirectCallback = function () {
        return __awaiter(this, void 0, void 0, function () {
            var queryString, isSignedIn, _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        // abort if inside iframe
                        if (window.self !== window.top)
                            return [2 /*return*/, false];
                        queryString = window.location.search.substr(1);
                        isSignedIn = false;
                        _b.label = 1;
                    case 1:
                        _b.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, this.convertToToken(queryString)];
                    case 2:
                        isSignedIn = _b.sent();
                        return [3 /*break*/, 4];
                    case 3:
                        _a = _b.sent();
                        return [3 /*break*/, 4];
                    case 4: return [2 /*return*/, isSignedIn];
                }
            });
        });
    };
    /**
     * ```js
     * lpClient.signOut();
     * ```
     *
     * Remove the cached token.
     */
    LaravelPassportClient.prototype.signOut = function () {
        this._token = undefined;
    };
    // *** Internal
    /**
     * Cache the token for this client.
     * @param token
     */
    LaravelPassportClient.prototype.storeToken = function (token) {
        this._token = token;
    };
    /**
     * Build the authorization request URL for this client and given AuthorizeParameters.
     * @param authorizationRequest
     */
    LaravelPassportClient.prototype.buildAuthorizeUrl = function (authorizationRequest) {
        return __awaiter(this, void 0, void 0, function () {
            var queryString, url;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, authorizationRequest.asQueryString()];
                    case 1:
                        queryString = _a.sent();
                        url = cleanUrl(this.domain + "/" + this.oauthPrefix + "/authorize");
                        return [2 /*return*/, url + "?" + queryString];
                }
            });
        });
    };
    /**
     * Creates AuthorizationRequest for this client. If provided, the given scope value will override
     * the client's default scope.
     * @param scope
     */
    LaravelPassportClient.prototype.buildAuthorizationRequest = function (scope) {
        return new AuthorizationRequest({
            client_id: this.client_id,
            redirect_uri: this.redirect_uri,
            scope: scope || this.scope,
        });
    };
    /**
     * Execute the sign in process with given method for given scope. Resolves on `true` if the sign
     * in has been successful, `false` otherwise.
     * @param method
     * @param scope
     */
    LaravelPassportClient.prototype.executeSignIn = function (method, scope) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                // create unique sign in request
                if (!currentSignInRequest) {
                    currentSignInRequest = new Promise(function (resolve, reject) { return __awaiter(_this, void 0, void 0, function () {
                        var authorizationRequest, url, _a, queryString, _b, _c;
                        return __generator(this, function (_d) {
                            switch (_d.label) {
                                case 0:
                                    authorizationRequest = this.buildAuthorizationRequest(scope);
                                    authorizationRequest.storeState();
                                    return [4 /*yield*/, this.buildAuthorizeUrl(authorizationRequest)];
                                case 1:
                                    url = _d.sent();
                                    _a = method;
                                    switch (_a) {
                                        case 'redirect': return [3 /*break*/, 2];
                                        case 'iframe': return [3 /*break*/, 3];
                                    }
                                    return [3 /*break*/, 3];
                                case 2:
                                    window.location.assign(url);
                                    reject();
                                    return [3 /*break*/, 7];
                                case 3:
                                    _d.trys.push([3, 6, , 7]);
                                    return [4 /*yield*/, runIframe(url)];
                                case 4:
                                    queryString = _d.sent();
                                    _b = resolve;
                                    return [4 /*yield*/, this.convertToToken(queryString)];
                                case 5:
                                    _b.apply(void 0, [_d.sent()]);
                                    return [2 /*return*/];
                                case 6:
                                    _c = _d.sent();
                                    authorizationRequest.clearState();
                                    reject();
                                    return [3 /*break*/, 7];
                                case 7:
                                    // if we get here, the sign in failed
                                    reject();
                                    return [2 /*return*/];
                            }
                        });
                    }); })
                        .catch(function () {
                        return false;
                    })
                        .finally(function () {
                        currentSignInRequest = undefined;
                    });
                }
                return [2 /*return*/, currentSignInRequest];
            });
        });
    };
    /**
     * Use the given query string to make an Authorization and sign in with it.
     * @param queryString
     * @throws If given query string is empty
     */
    LaravelPassportClient.prototype.convertToToken = function (queryString) {
        return __awaiter(this, void 0, void 0, function () {
            var authorization;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        authorization = this.makeAuthorization(queryString);
                        return [4 /*yield*/, this.signInWithAuthorization(authorization)];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    /**
     * Parse the given query string and returns an Authorization with the parsed parameters.
     * @param queryString
     * @throws If given query string is empty
     */
    LaravelPassportClient.prototype.makeAuthorization = function (queryString) {
        // nothing returned
        if (queryString.length === 0) {
            throw new Error('No query response parameters found.');
        }
        // parse query
        var _a = parseQueryResult(queryString), code = _a.code, state = _a.state;
        // create authorization
        return new Authorization({ code: code, state: state });
    };
    /**
     * Exchange the given Authorization for a token. Returns `true` if sign in was successful,
     * `false` otherwise.
     * @param authorization
     * @throws if the recieved token's scope does not match the scope from authorization
     */
    LaravelPassportClient.prototype.signInWithAuthorization = function (authorization) {
        return __awaiter(this, void 0, void 0, function () {
            var authorizationSignature, token, e_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        authorizationSignature = authorization.getSignature();
                        return [4 /*yield*/, this.getTokenFromServer(authorizationSignature)];
                    case 1:
                        token = _a.sent();
                        // validate scope
                        if (authorization.scope !== token.scopesAsString()) {
                            throw new Error("Authorized scope does not match the recieved token's scope");
                        }
                        // store token
                        this.storeToken(token);
                        return [2 /*return*/, true];
                    case 2:
                        e_1 = _a.sent();
                        // remove token
                        this.signOut();
                        return [3 /*break*/, 3];
                    case 3: return [2 /*return*/, false];
                }
            });
        });
    };
    /**
     * Runs an XHTTP token request to the authentication server with given authorization signature.
     * @param authorizationSignature
     */
    LaravelPassportClient.prototype.getTokenFromServer = function (authorizationSignature) {
        return __awaiter(this, void 0, void 0, function () {
            var url, tokenResponse;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        url = cleanUrl(this.domain + "/" + this.oauthPrefix + "/token");
                        return [4 /*yield*/, getJSON(url, {
                                method: 'POST',
                                body: JSON.stringify(__assign({ grant_type: 'authorization_code', client_id: this.client_id, redirect_uri: this.redirect_uri }, authorizationSignature)),
                            })];
                    case 1:
                        tokenResponse = _a.sent();
                        // no access token given
                        if (!tokenResponse.access_token) {
                            throw new Error('Invalid token response');
                        }
                        return [2 /*return*/, new JWT(tokenResponse.access_token)];
                }
            });
        });
    };
    return LaravelPassportClient;
}());
export { LaravelPassportClient };
//# sourceMappingURL=LaravelPassportClient.js.map