export declare class JWT {
    raw: string;
    client_id: number;
    token_id: string;
    issued_at: Date;
    expiration: Date;
    not_before: Date;
    user_id: number;
    scopes: string[];
    /**
     * Represent a JSON Web Token. Values are decoded from given `encodedToken` string for easier
     * usage.
     * @param encodedToken
     */
    constructor(encodedToken: string);
    /**
     * Returns `false` if the JWT's expiration date is in the future, `true` otherwise.
     */
    isExpired(): boolean;
    /**
     * Get the scopes of the token as a string where each scope is separated by a space. If no scopes
     * are present, the general scope `'*'` is returned.
     */
    scopesAsString(): string;
}
