/**
 * Encode given string to base64.
 * @param str
 */
export declare const encodeState: (str: string) => string;
/**
 * Decode given base64 string.
 * @param str
 */
export declare const decodeState: (str: string) => string;
/**
 * Encode given string to url compliant base64.
 * @param url
 */
export declare const urlEncodeB64: (url: string) => string;
/**
 * Decode given base64 url part.
 * @param urlPart
 */
export declare const urlDecodeB64: (urlPart: string) => string;
/**
 * Encode given array buffer to base64.
 * @param arrBuffer
 */
export declare const bufferToBase64UrlEncoded: (arrBuffer: ArrayBuffer) => string;
