/**
 * Get the browser's crypto module.
 */
export declare const getCrypto: () => Crypto;
/**
 * Get the browser's crypto subtle module.
 */
export declare const getCryptoSubtle: () => SubtleCrypto;
/**
 * Validate that the browswer has the crypto module.
 */
export declare const validateCrypto: () => void;
/**
 * Create a random string containing only alpha-numeric characters (upper and lower case) as well
 * as `-`, `_`, `~` and `.` . Uses `crypto.getRandomValues()` as seed.
 */
export declare const createRandomString: () => string;
/**
 * Hash the given string using SHA256 algorithm.
 * @param str
 */
export declare const sha256: (str: string) => Promise<ArrayBuffer>;
