// https://stackoverflow.com/questions/30106476/
var decodeB64 = function (input) {
    return decodeURIComponent(atob(input)
        .split('')
        .map(function (c) {
        return '%' + ('00' + c.charCodeAt(0).toString(16)).slice(-2);
    })
        .join(''));
};
/**
 * Encode given string to base64.
 * @param str
 */
export var encodeState = function (str) { return btoa(str); };
/**
 * Decode given base64 string.
 * @param str
 */
export var decodeState = function (str) { return atob(str); };
/**
 * Encode given string to url compliant base64.
 * @param url
 */
export var urlEncodeB64 = function (url) {
    var b64Chars = { '+': '-', '/': '_', '=': '' };
    return url.replace(/[\+\/=]/g, function (m) { return b64Chars[m]; });
};
/**
 * Decode given base64 url part.
 * @param urlPart
 */
export var urlDecodeB64 = function (urlPart) {
    return decodeB64(urlPart.replace(/_/g, '/').replace(/-/g, '+'));
};
/**
 * Encode given array buffer to base64.
 * @param arrBuffer
 */
export var bufferToBase64UrlEncoded = function (arrBuffer) {
    var ie11SafeInput = new Uint8Array(arrBuffer);
    return urlEncodeB64(window.btoa(String.fromCharCode.apply(String, Array.from(ie11SafeInput))));
};
//# sourceMappingURL=base64.js.map