var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
/**
 * Get the browser's crypto module.
 */
export var getCrypto = function () {
    //ie 11.x uses msCrypto
    return window.crypto || window.msCrypto;
};
/**
 * Get the browser's crypto subtle module.
 */
export var getCryptoSubtle = function () {
    var crypto = getCrypto();
    //safari 10.x uses webkitSubtle
    return crypto.subtle || crypto.webkitSubtle;
};
/**
 * Validate that the browswer has the crypto module.
 */
export var validateCrypto = function () {
    if (!getCrypto()) {
        throw new Error('For security reasons, `window.crypto` is required to run `laravel-passport-spa-js`.');
    }
    if (typeof getCryptoSubtle() === 'undefined') {
        throw new Error("\n      laravel-passport-spa-js must run on a secure origin.\n      See https://github.com/auth0/auth0-spa-js/blob/master/FAQ.md#why-do-i-get-auth0-spa-js-must-run-on-a-secure-origin \n      for more information.\n    ");
    }
};
/**
 * Create a random string containing only alpha-numeric characters (upper and lower case) as well
 * as `-`, `_`, `~` and `.` . Uses `crypto.getRandomValues()` as seed.
 */
export var createRandomString = function () {
    var charset = '0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz-_~.';
    var random = '';
    var randomValues = Array.from(getCrypto().getRandomValues(new Uint8Array(43)));
    randomValues.forEach(function (v) { return (random += charset[v % charset.length]); });
    return random;
};
/**
 * Hash the given string using SHA256 algorithm.
 * @param str
 */
export var sha256 = function (str) { return __awaiter(void 0, void 0, void 0, function () {
    var digestOp, digestOpMs_1;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                digestOp = getCryptoSubtle().digest({ name: 'SHA-256' }, new TextEncoder().encode(str));
                // msCrypto (IE11) uses the old spec, which is not Promise based
                // https://msdn.microsoft.com/en-us/expression/dn904640(v=vs.71)
                // Instead of returning a promise, it returns a CryptoOperation
                // with a result property in it.
                // As a result, the various events need to be handled in the event that we're
                // working in IE11 (hence the msCrypto check). These events just call resolve
                // or reject depending on their intention.
                if (window.msCrypto) {
                    digestOpMs_1 = digestOp;
                    return [2 /*return*/, new Promise(function (res, rej) {
                            digestOpMs_1.oncomplete = function (e) {
                                res(e.target.result);
                            };
                            digestOpMs_1.onerror = function (e) {
                                rej(e.error);
                            };
                            digestOpMs_1.onabort = function () {
                                rej('The digest operation was aborted');
                            };
                        })];
                }
                return [4 /*yield*/, digestOp];
            case 1: return [2 /*return*/, _a.sent()];
        }
    });
}); };
//# sourceMappingURL=crypto.js.map