/**
 * Returns an array with unique values of the given array.
 * @param arr
 */
export var dedupe = function (arr) { return arr.filter(function (x, i) { return arr.indexOf(x) === i; }); };
/**
 * Implode given `string` `string[]` inputs to a string with only unique values separated by `' '`.
 * Input strings containing coma separated list are splitted into arrays of string.
 */
export var implodeMultiple = function () {
    var input = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        input[_i] = arguments[_i];
    }
    // remove falsy values
    var values = input.filter(Boolean).join();
    // get unique values
    var uniqueValues = dedupe(values.replace(/\s/g, ',').split(','));
    return uniqueValues.join(' ').trim();
};
//# sourceMappingURL=general.js.map