/**
 * Parse the given query string and returns it as a key-value dictionnary.
 * @param queryString
 */
export var parseQueryResult = function (queryString) {
    if (queryString.indexOf('#') > -1) {
        queryString = queryString.substr(0, queryString.indexOf('#'));
    }
    var queryParams = queryString.split('&');
    var parsedQuery = {};
    queryParams.forEach(function (qp) {
        var _a = qp.split('='), key = _a[0], val = _a[1];
        parsedQuery[key] = decodeURIComponent(val);
    });
    return parsedQuery;
};
/**
 * Concatenates the given key-value dictionnary into a query string. Note that is not prefiexed
 * with a question mark!
 * @param params
 */
export var createQueryParams = function (params) {
    return Object.keys(params)
        .filter(function (k) { return typeof params[k] !== 'undefined'; })
        .map(function (k) { return encodeURIComponent(k) + '=' + encodeURIComponent(params[k]); })
        .join('&');
};
//# sourceMappingURL=queryString.js.map